import java.io.*;
import java.util.*;

public class C {
    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] output = new int[m];
        LinkedList<Integer> cards = new LinkedList();
        LinkedList all[] = new LinkedList[n];
        for (int i = 0; i < n; i++) {
            all[i] = new LinkedList();
        }
        for (int i = 0; i < m; i++) {
            output[i] = nextInt() - 1;
            all[output[i]].addLast(i);
        }
        int[] maxPlacePlusTime = new int[m];
        int pos = 0;
        for (int i = 0; i < n; i++) {
            int g = nextInt() - 1;
            if (g == output[pos]) {
                maxPlacePlusTime[pos] = i;
                pos++;
            }
            cards.addLast(g);
        }
        for (int i = pos; i < m; i++) {
            maxPlacePlusTime[i] = maxPlacePlusTime[pos - 1];
        }
        int outnow = 0;
        int time = 0;
        ArrayList<Integer> o = new ArrayList<>();
        while (outnow < output.length) {
            int p = cards.peekFirst();
            if (p == output[outnow]) {
                outnow++;
                all[p].removeFirst();
            }
            cards.removeFirst();
            if (all[p].isEmpty()) {
                cards.add(cards.size(), p);
                o.add(cards.size() - 1);
            } else {
                cards.add((maxPlacePlusTime[(int) all[p].peekFirst()] - time), p);
                o.add((maxPlacePlusTime[(int) all[p].peekFirst()] - time));
                for (int i = (int) all[p].peekFirst(); i < maxPlacePlusTime.length; i++) {
                    maxPlacePlusTime[i]++;
                }
            }
            time++;
        }
        System.out.println(time);
        for (int i : o) {
            System.out.print((i + 1) + " ");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }
}