import java.io.*;
import java.util.*;

public class C {
    static Node[] addT;

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] output = new int[m];
        LinkedList<Integer> cards = new LinkedList();
        LinkedList all[] = new LinkedList[n];
        for (int i = 0; i < n; i++) {
            all[i] = new LinkedList();
        }
        for (int i = 0; i < m; i++) {
            output[i] = nextInt() - 1;
            all[output[i]].addLast(i);
        }
        int[] maxPlacePlusTime = new int[m];
        int pos = 0;
        for (int i = 0; i < n; i++) {
            int g = nextInt() - 1;
            if (g == output[pos]) {
                maxPlacePlusTime[pos] = i;
                pos++;
            }
            cards.addLast(g);
        }
        for (int i = pos; i < m; i++) {
            maxPlacePlusTime[i] = maxPlacePlusTime[pos - 1];
        }
        int q = 1;
        while (q < m) q *= 2;
        addT = new Node[2 * q];
        for (int i = q; i < 2 * q; i++) {
            addT[i] = new Node(i, addT, false);
        }
        for (int i = q - 1; i > 0; i--) {
            addT[i] = new Node(i, addT, true);
        }
        int outnow = 0;
        int time = 0;
        ArrayList<Integer> o = new ArrayList<>();
        while (outnow < output.length) {
            int p = cards.peekFirst();
            if (p == output[outnow]) {
                outnow++;
                all[p].removeFirst();
            }
            cards.removeFirst();
            if (all[p].isEmpty()) {
                cards.add(cards.size(), p);
                o.add(cards.size() - 1);
            } else {
                pos = get((Integer) all[p].peekFirst(), 1) + maxPlacePlusTime[(int) all[p].peekFirst()] - time;
                cards.add(pos, p);
                o.add(pos);
                add(pos + time, 1);
            }
            time++;
        }
        System.out.println(time);
        for (int i : o) {
            System.out.print((i + 1) + " ");
        }
    }

    private int get(int sp, int p) {
        int ret = addT[p].m;
        if (p < (addT.length - 1) / 2) {
            if (addT[2 * p].ro >= sp) {
                ret += get(sp, p * 2);
            } else ret += get(sp, p * 2 + 1);
        }
        return ret;
    }

    private void add(int l, int pos) {
        if (addT[pos].lo >= l) {
            addT[pos].m++;
            return;
        }
        if (addT[pos * 2].ro >= l) {
            add(l, 2 * pos);
        }
        add(l, 2 * pos + 1);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }
}

class Node {
    int m;
    int lo;
    int ro;

    Node(int num, Node[] addT, boolean is) {
        m = 0;
        if (is) {
            lo = addT[2 * num].lo;
            ro = addT[2 * num + 1].ro;
        } else {
            lo = ro = num - addT.length / 2;
        }
    }
}