import java.io.*;
import java.util.*;

public class D {
    public void solve() throws IOException {
        long div = 1000000007;
        long n = nextInt();
        int m = nextInt();
        long k = nextLong();
        ArrayList<Integer> bits = new ArrayList<>();
        while (k > 0) {
            bits.add(0, Math.toIntExact(k % 2));
            k /= 2;
        }
        long res = 0;
        long count = 1;
        for (int i = 0; i < bits.size(); i++) {
            if (bits.get(i) == 1) {
                long locres = 1;
                for (int j = 1; j < bits.size() - i; j++) {
                    locres *= (n + 1);
                    locres %= div;
                }
                for (int j = 1; j < count; j++) {
                    locres *= n;
                    locres %= div;
                }
                count++;
                res += locres;
                res %= div;
            }
        }
        long locres = 1;
        for (int j = 1; j < count; j++) {
            locres *= n;
            locres %= div;
        }
        res += locres;
        /*
        long locres = 1;
        for (int i = 1; i < bits.size(); i++) {
            locres *= (n + 1);
            locres %= div;
        }
        res += locres;
        res %= div;
        locres = n;
        for (int i = 1; i < count; i++) {
            locres *= (n + 1);
            locres %= div;
        }
        res += locres;*/
        res %= div;
        System.out.println(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}