import java.io.*;
import java.util.*;

public class D {
    public void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        Art[] pip = new Art[n];
        for (int i = 0; i < n; i++) {
            pip[i] = new Art((int) (Math.random() * 10000), i + 1);
        }
        Arrays.sort(pip, Comparator.comparingInt(o -> o.a));
        out.write("YES");
        for (int i = 0; i < pip.length / 2; i++) {
            out.write(pip[i].num + " " + pip[pip.length - i - 1].num);
        }
    }

    public void run() {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
        out.close();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}

class Art {
    int a;
    int num;

    Art(int _a, int _num) {
        a = _a;
        num = _num;
    }
}