import java.io.*;
import java.util.*;

public class D {
    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        long k = nextLong();
        ArrayList<Integer> bits = new ArrayList<>();
        while (k > 0) {
            bits.add(0, Math.toIntExact(k % 2));
            k /= 2;
        }
        long res = 0;
        long locres = 1;
        for (int i = 1; i < bits.size(); i++) {
            locres *= (n + 1);
            locres %= 1000000007;
        }
        res += locres;
        res %= 1000000007;
        int count = 0;
        for (int i = 0; i < bits.size(); i++) {
            count += bits.get(i);
        }
        locres = n;
        for (int i = 1; i < count; i++) {
            locres *= (n + 1);
            locres %= 1000000007;
        }
        res += locres;
        res %= 1000000007;
        System.out.println(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}