import java.util.Scanner;

public class B {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int k = sc.nextInt();
        if (k == n) {
            System.out.println(1);
            return;
        }
        int[][] rise = new int[n][n - k + 1];
        int[][] down = new int[n][n - k + 1];
        int res = 0;
        rise[k - 1][k - 1] = 1;
        down[k - 1][k - 1] = 1;
        while (true) {
            int[][][] r = next(rise, down);
            rise = r[0];
            down = r[1];
            int resP = res;
            for (int i = 0; i < rise[n - 1].length; i++) {
                res += rise[n - 1][i];
                res += down[n - 1][i];
                res %= 1000000007;
            }
            if (resP == res) break;
        }
        System.out.println(res);
    }

    private static int[][][] next(int[][] rise, int[][] down) {
        int[][] riseNext = new int[rise.length][rise[0].length];
        int[][] downNext = new int[rise.length][rise[0].length];
        for (int i = 2; i < rise.length; i++) {
            for (int j = 1; j < Math.min(rise[0].length, i); j++) {
                for (int k = 1; k < j; k++) {
                    riseNext[i][j - 1] += down[i - j][k - 1];
                    riseNext[i][j - 1] %= 100000007;
                }
                for (int k = rise[0].length; k > j; k--) {
                    downNext[i][j - 1] += rise[i - j][k - 1];
                    downNext[i][j - 1] %= 100000007;
                }
            }
        }
        return new int[][][]{riseNext, downNext};
    }
}
